
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Jenkins管道最佳实践Top 10 / iVAN</title>

    <meta name="description" content="Jenkins管道最佳实践Top 10 本文讲的是Jenkins管道最佳实践Top 10[编者的话]Andy Pemberton领导CloudBees的解决方案架构团队.CloudBees是一家依赖Jenkins实现云化持续集成平台的创业公司,目前已经得到C轮融资.Andy拥有超过十年的软件交付经验,同时他也是经常发表演讲和撰写博客.本文是Andy做为Jenkins专家给出的10条Jenkins管道化使用的最佳实践. Jenkins的管道化插件对于其用户来说是个变局者.依赖于域领域语言(DSL)Groovy,管道化插件实现了脚本化.这">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Jenkins管道最佳实践Top 10</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>本文讲的是<b>Jenkins管道最佳实践Top 10</b>【编者的话】Andy Pemberton领导CloudBees的解决方案架构团队。CloudBees是一家依赖Jenkins实现云化持续集成平台的创业公司，目前已经得到C轮融资。Andy拥有超过十年的软件交付经验，同时他也是经常发表演讲和撰写博客。本文是Andy做为Jenkins专家给出的10条Jenkins管道化使用的最佳实践。</p>
<p>Jenkins的管道化插件对于其用户来说是个变局者。依赖于域领域语言（DSL）Groovy，管道化插件实现了脚本化。这对于开发复杂且步骤繁多的DevOps管道非常有帮助。本文提供了你最应该知道的关于Jekins管道化插件中“要做”和“不要做”的最佳实践-并且包含代码示例。</p>
<p><a href="http://dockerone.com/uploads/article/20160713/a7a5d1e4cc74cf212308f1256c4d10d4.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvZG9ja2Vyb25lLmNvbS91cGxvYWRzL2FydGljbGUvMjAxNjA3MTMvYTdhNWQxZTRjYzc0Y2YyMTIzMDhmMTI1NmM0ZDEwZDQucG5n.jpg"></a></p>
<h3>1. 要做：使用真正的Jenkins管道化插件</h3>
<p>不要使用诸如Build Pipeline和Buildflow等老插件。应该使用真正的<a href="https://wiki.jenkins-ci.org/display/JENKINS/Pipeline+Plugin" rel="external nofollow noreferrer">Jenkins管道化插件套件</a>。</p>
<p>为什么呢？因为管道化插件是在底层任务上的一种改善。与那些自由式的插件不同，管道化插件对于Jenkins主节点重启是有感知能力的，并且包含了一些內建的功能。这些功能在构建多步骤、复杂的发布管道时，效果大大超越了之前的老式插件。</p>
<p>更多关于管道化的内容：<a href="https://jenkins.io/solutions/pipeline/" rel="external nofollow noreferrer">https://jenkins.io/solutions/pipeline/</a><br />
<h3>2. 要做：像写代码一样开发你的管道</h3>
<p>使用这种方法你可以在SCM中存储Jenkinsfile。并且像写其他软件一样的去版本化和测试它。</p>
<p>为什么要这么做呢？把你的管道作为代码会强化一种约束，并且得到GitHub和BitBucket提供的多种新功能，诸如：多分支，pull request检查和组织扫描。</p>
<p><a href="http://dockerone.com/uploads/article/20160713/331f7101b86e57dfbbddd25de52ac38f.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvZG9ja2Vyb25lLmNvbS91cGxvYWRzL2FydGljbGUvMjAxNjA3MTMvMzMxZjcxMDFiODZlNTdkZmJiZGRkMjVkZTUyYWMzOGYucG5n.jpg"></a></p>
<p>你需要给你的管道脚本一个默认名字：Jenkinsfile，并且以如下的内容作为脚本头，这样的话你的IDE、GitHub和其他工具会识别出来脚本是Groovy，并提供语法高亮功能：
<pre>#!groovy
</pre>
<p><h3>3. 要做：所有工作都要放到Stage中</h3>
<p>你的管道中任何非初始化的任务都要放到一个Stage块中。</p>
<p>为什么呢？因为Stage是管道的逻辑段。将任务分拆到不同Stage中等同于你将管道拆分成一个个独立的任务段。<br />
<h4>例子：</h4>
<pre>stage 'build'
//build
stage 'test'
//test
</pre>
<p>并且有福利哦：Pipeline Stage View插件可以将管道中的一个个段进行可视化：</p>
<p><a href="http://dockerone.com/uploads/article/20160713/4a3bdb6163835f39c3f4cd464b0fbe50.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvZG9ja2Vyb25lLmNvbS91cGxvYWRzL2FydGljbGUvMjAxNjA3MTMvNGEzYmRiNjE2MzgzNWYzOWMzZjRjZDQ2NGIwZmJlNTAucG5n.jpg"></a></p>
<h3>4. 要做：将重量级的任务放到单独节点中执行</h3>
<p>任何管道中重量级的工作需要放到Node块中执行。</p>
<p>为什么呢？因为默认情况下，Jenkinsfile脚本运行在Jenkins的主节点中，并且为了减少资源的消耗而使用了轻型的执行器。任何重量级的工作，例如从Git上下载代码或编译Java应用，需要使用Jenkins的分布式构建能力并且运行在代理节点中。<br />
<h4>例子：</h4>
<pre>stage 'build'
node{
checkout scm
sh 'mvn clean install'
} 
</pre>
<p><h3>5. 要做：可以将任务放到并行步骤中</h3>
<p>管道提供了一个向前（straight-forward）的语法来支持将你的管道拆分成并行的步骤。推荐使用它。</p>
<p>为什么呢？因为将任务转为并行可以加快你的管道运行，将你的管道步骤放到“left”中，开发者和团队其他的成员会更快的得到反馈。<br />
<h4>例子</h4>
<pre>parallel 'shifting':{
//everything
}, 'left':{
//I can
} 
</pre>
<p>提示：使用<a href="https://wiki.jenkins-ci.org/display/JENKINS/Parallel+Test+Executor+Plugin" rel="external nofollow noreferrer">并行测试执行插件</a>可以使Jenkins自动决定如何在可选的并行桶中运行你的单元测试！获取详细信息请阅读<a href="https://www.cloudbees.com/blog/parallelism-and-distributed-builds-jenkins" rel="external nofollow noreferrer">Parallel Test Execution on the CloudBees Blog</a>。<br />
<h3>6. 要做：在节点中执行并行步骤</h3>
<p>为什么呢？管道并行化最大的好处是：做更多的重量级任务（参见最佳实践4）！通常情况下你需要在管道并行分支内部使用一个节点。<br />
<h4>例子：</h4>
<pre>parallel 'integration-tests':{
node('mvn-3.3'){ ... }
}, 'functional-tests':{
node('selenium'){ ... }
} 
</pre>
<p><h3>7. 不要做：在Node块中使用Input</h3>
<p>你千万不要在Node块内部使用input语句。</p>
<p>为什么呢？因为输入会暂停管道的执行，去等待自动的或手动的输入。自然这类等待一定会占用时间。而另一方面，node语句在工作区上获取并持有锁和重型的Jenkins执行器，去获取这么昂贵的资源而仅仅为了停下来等待输入是不合适的。</p>
<p>所以，请在Node的外部创建input输入。<br />
<h4>例子：</h4>
<pre>stage 'deployment'
input 'Do you approve deployment?'
node{
//deploy the things
} 
</pre>
<p><h3>8. 要做：为你的输入设置超时时间</h3>
<p>管道有一套很简单的机制来应对任务的超时。这其中的最佳实践是：你应该总是为你的输入规划好超时时间。</p>
<p>为什么呢？为了管道的健康清理，这就是原因。当输入的内容在指定时间窗口内没有送达时，将你的输入包装到一个超时内部可以使它们被清理掉（例如：被暂停）。<br />
<h4>例子：</h4>
<pre>timeout(time:5, unit:'DAYS') {
input message:'Approve deployment?', submitter: 'it-ops'
} 
</pre>
<p><h3>9. 不要做：使用env全局变量设置环境变量</h3>
<p>如果你想在env全局变量中编辑一些设置时，你应该使用withEnv语法来这么做。</p>
<p>为什么呢？因为env变量是全局的，直接改变它是不被鼓励的，因为它改变了全局的环境。所以withEnv语法是被推荐使用的。<br />
<h4>例子：</h4>
<pre>withEnv(["PATH+MAVEN=${tool 'm3'}/bin"]) {
sh "mvn clean verify"
} 
</pre>
<p><h3>10. 要做：选择暂存文件而不是归档文件</h3>
<p>在暂存能力被添加到管道化DSL之前，归档是在node和stage之间共享文件的最佳方案。如果你仅仅是想在stage和node之间共享文件，那么你应该使用stash/unstash，而不是archive。</p>
<p>为什么呢？因为暂存是被设计为共享文件的，例如：在stage和node之间共享你的应用源代码。而另外一方面，归档是被设计为长期存储文件的（例如：你的构建的中间二进制文件）。<br />
<h4>例子：</h4>
<pre>stash excludes: 'target/', name: 'source'
unstash 'source'
</pre>
<p><h3>总结</h3>
<p>感谢您的阅读！新的Jenkins管道化插件已经获得了越来越多的关注，特别是在<a href="https://jenkins.io/2.0/" rel="external nofollow noreferrer">Jenkins 2.0</a>发布后。我也同时相信随着全世界的开发者使用Jenkins开发他们的DevOps管道，将会有越来越多的最佳实践产生出来。</p>
<p>原文链接：<a href="https://dzone.com/articles/top-10-best-practices-for-jenkins-pipeline" rel="external nofollow noreferrer">Top 10 Best Practices for Jenkins Pipeline</a> （翻译：高洪涛）</p>
<p>===========================================<br />译者介绍</p>
<p>高洪涛，当当网架构师，开源数据库分库分表中间件Sharding-JDBC作者。目前从事Docker相关研究工作。</p>
<p>原文发布时间为：2016-07-13</p>
<p>本文作者：高洪涛</p>
<p>本文来自合作伙伴Dockerone.io，了解相关信息可以关注Dockerone.io。</p>
<p>原文标题：Jenkins管道最佳实践Top 10</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-01 21:45:53</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%8f%92%e4%bb%b6/" title="插件">插件</a>, <a href="https://www.iamivan.net/tag/input/" title="input">input</a>, <a href="https://www.iamivan.net/tag/node/" title="node">node</a>, <a href="https://www.iamivan.net/tag/%e8%84%9a%e6%9c%ac/" title="脚本">脚本</a>, <a href="https://www.iamivan.net/tag/jenkins/" title="jenkins">jenkins</a>, <a href="https://www.iamivan.net/tag/pipeline/" title="pipeline">pipeline</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Jenkins管道最佳实践Top 10的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zDem4rb.html" rel="bookmark">CloudDBA最佳实践-TOP SQL优化分析数据库性能问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				    云数据库CloudDBA诊断报告的TOP SQL优化是非常实用的功能,我们可以通过TOP SQL去诊断数据库中各种问题,比如性能出现下降,数据库压力出现波动,下面介绍两个线上生产案例.     一. 利用CloudDBA TOP SQL找出数据库规格升级而性能下降的元凶     最近在协助用户进行系统重构,RDS测试选型自然成为了本项目的一个重点,但是用户在测试不同规格的时候发现大规格的实例性能居然不如小规格,4C32G规格性能比8C64G规格高出10%,其性能监控也是非常的正常,4C3			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlK5VOb.html" rel="bookmark">2017年度TOP 10大数据应用最佳实践 案例征集活动最新启动</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				2017年5月18日上午,CCF大数据专家委员会召开新闻会,正式发布和启动了&quot;2017年度TOP10大数据应用最佳实践案例征集&quot;活动. CCF大数据专家委员会副秘书长.北京启明星辰信息技术有限公司首席战略官潘柱廷(左),中国科学院计算技术研究所副研究员查礼(右) 发布会上,CCF大数据专家委员会副秘书长.北京启明星辰信息技术有限公司首席战略官潘柱廷,中国科学院计算技术研究所副研究员查礼代表活动发起方,向现场数十家记者阐述了2017年大数据技术发展的现状及未来趋势,并就本次最佳实践案例征			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pn7q2Az.html" rel="bookmark">Java中关于异常处理的10个最佳实践</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Java 编程中异常处理的最佳实践 这里是我收集的10个Java编程中进行异常处理的10最佳实践.在Java编程中对于检查异常有褒有贬,强制处理异常是一门语言的功能.在本文中,我们将尽量减少使用检查型异常,同时学会在Java编程中使用检查型VS非检查型异常. 1.为可恢复的错误使用检查型异常,为编程错误使用非检查型错误 选择检查型还是非检查型异常,对于Java编程人员来说,总是让人感到困惑.检查型异常保证你对错误条件提供异常处理代码,这是一种从语言到强制你编写健壮的代码的一种方式,但同时会引入大			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bQjg90M.html" rel="bookmark">PostgreSQL 10&period;0 逻辑复制原理与最佳实践</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				标签 PostgreSQL , logical replication , 逻辑复制 , 最佳实践 背景 PostgreSQL 从2010年发布的9.0开始支持流式物理复制,备库可以作为只读库打开,提供给用户使用. 物理复制的好处 1. 物理层面完全一致,这是许多商业数据库的惯用手段.例如Oracle的DG. 2. 延迟低,事务执行过程中产生REDO record,实时的在备库apply,事务结束时,备库立马能见到数据.不论事务多大,都一样. 3. 物理复制的一致性.可靠性达到了金融级的需求,不			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPknq1M.html" rel="bookmark">PostgreSQL 10 流式物理、逻辑主从 最佳实践</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				标签 PostgreSQL , 流复制 , 主从 , 逻辑订阅 背景 流复制起源 PostgreSQL 自从2010年推出的9.0版本开始,支持流式物理复制,用户可以通过流式复制,构建只读备库(主备物理复制,块级别一致).流式物理复制可以做到极低的延迟(通常在1毫秒以内). 同步流复制 2011年推出的9.1版本,支持同步复制,当时只支持一个同步流复制备节点(例如配置了3个备,只有一个是同步模式的,其他都是异步模式). 在同步复制模式下,当用户提交事务时,需要等待这笔事务的WAL日志复制到同步流			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M0YQoAp.html" rel="bookmark">《配置管理最佳实践》&mdash;&mdash;2&period;10&emsp;建立构建过程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				2.10 建立构建过程 实施构建工程最佳实践是一项非常具有挑战性的工作.构建工程师可以选择有益于公司的实践:也可以选择最好的工具去建立可重复的构建,实施持续集成.但是实际工作远不止此,构建工程部门还需要为开发团队提供培训和技术支持.我的经验是和研发团队合作,解决构建和部署过程中的问题,然后转到幕后做支持,把日常的工作还交给开发团队来负责.这里有个前提就是公司的合规部门允许这样做.曾经一家实施 SAS-70的公司认为可以接受这样的做法:但是另外一家公司认为这不合规,不能接受.在一些公司里因为合规的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zDj8BLM.html" rel="bookmark">DevOps的10个最佳实践</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				2015年6月,Gartner预测说,&quot;到2017年年底,对移动应用开发服务的市场需求将比内部IT机构交付这些服务的能力快至少5倍.&quot;事实上,企业上下已经看到他们的应用工作负载在飙升.因此,越来越多的企业机构正在采用DevOps--这种方法通过让应用开发者和运营专家在整个端到端应用开发和部署过程中的协作来加速应用开发和交付.以下是10个正在获得组织机构青睐的DevOps最佳实践. 1.打破IT孤岛 打破IT中各项职能间的功能性孤岛必须来自于上层管理,因为数十年来IT一直以约束性的孤岛组			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M6qEAYb.html" rel="bookmark">Android应用性能优化最佳实践&period;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				移动开发 Android应用性能优化最佳实践 罗彧成 著 图书在版编目(CIP)数据 Android应用性能优化最佳实践 / 罗彧成著. -北京:机械工业出版社,2017.1 (移动开发) ISBN 978-7-111-55616-9 I. A- II. 罗- III. 移动终端-应用程序-程序设计 IV. TN929.53 中国版本图书馆CIP数据核字(2016)第315986号 Android应用性能优化最佳实践 出版发行:机械工业出版社(北京市西城区百万庄大街22号 邮政编码:100037			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Lp5dJnM.html" rel="bookmark">JSP 最佳实践：组合 JavaBean 组件和 JSP 技术</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				js JSP 最佳实践:组合 JavaBean 组件和 JSP 技术 使用 JavaBean 和 JSP 参数在 Web 页面之间传递数据级别:入门Brett McLaughlin(brett@oreilly.com)作家,O'Reilly and Associates2003 年 7 月 Web 架构设计师 Brett McLaughlin 演示了 JavaBean 组件和 JSP 技术的结合如何使您能够在 Web 页面之间存储并传递数据,以及这样做如何能实现更为动态的站点设计.到目前为止,我			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/gpk7gop.html" rel="bookmark" class="title">二十五个顶级PHP模板引擎整理</a>
					<div>
						   为了找到一个好的模板引擎,我在互联网上进行搜索,目前已经整理出了以下名单: Smarty   Smarty的特点是将模板编译成PHP脚本,然后执行这些脚本.很快,非常灵活. Heyes Temp ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/2pLQ5vz.html" rel="bookmark" class="title">ASP编程入门进阶&lpar;一&rpar; 安装配置服务器</a>
					<div>
						编程|服务器|服务器 申明:asp编程入门进阶系列文章COPY自http://www.cnbruce.com/blog/ 部分运行代码请到该站进行在线测试ASP编程入门进阶(一):安装配置服务器 鉴于 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/XpmN01z.html" rel="bookmark" class="title">ASP&period;Net 2&period;0中实现多语言界面的方法</a>
					<div>
						asp.net 1． 跟以前一样做界面,只是注意,把所有需要有多语言界面的文字都用label来做 2． 做完以后,在Solution Explorer里选中这个文件,选Tools-&gt;Genera ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/vbQ49Gz.html" rel="bookmark" class="title">Fireworks运用笔触制作飘逸白云</a>
					<div>
						相关文章: Fireworks 制作飘逸白云 1.用左侧[工具栏]上的[直线]工具在画布上随便画一条线 2.点击[属性]面板上的 线条颜色请选择近似灰紫色系的,如#EDEDF1. 3.鼠标点击 [描边 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/VMrkP1p.html" rel="bookmark" class="title">如何得到一个汉字和字母组合的字符串的准确的长度&lpar;asp&period;net 版本的&rpar;</a>
					<div>
						asp.net|汉字|字符串 在实际工作应用中,很多的时候会出现这样的情况,由于我们对于汉字的特殊的要求,在计算字符个数的时候,由于是Unicode的原因,我们对于一个 汉字 应该是按照两个字符计算, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMy5qkM.html" rel="bookmark" class="title">A Comparative Overview of C&num;中文版（三）</a>
					<div>
						中文 10.操作符重载     利用操作符重载机制,程序员可以创建让人感觉自然的好似简单类型(如int.long等等)的类.C#实现了一个C++操作符重载的限制版,它可以使诸如这样的精辟的例子-复数类 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9zeQ17z.html" rel="bookmark" class="title">kernel学习之进程抢占和切换</a>
					<div>
						抢占时伴随着schedule()的执行.内核提供了一个TIF_NEED_RESCHED标志来表明是否要用schedule()调度一次. 根据抢占发生的时机分为用户抢占和内核抢占.用户抢占发生在内核即将 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJ7Av2b.html" rel="bookmark" class="title">浅析Windows 2000的电源管理</a>
					<div>
						windows 2000(包括Microsoft Windows 2000 Professional.Microsoft Windows 2000 Server.Microsoft Windows 2 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/balZKwz.html" rel="bookmark" class="title">Spring DAO层的设计思想</a>
					<div>
						近几年持久化技术领域异常喧嚣,各种框架雨后春笋般地冒出,Sun也连接不断地颁布几个持久化规范.Spring对多个持久化技术提供了集成的支持,包括Hibernate.iBatis.JDO.JPA.Top ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrKGm6p.html" rel="bookmark" class="title">如何检查oracle表或索引可回收空间</a>
					<div>
						对表进行大量删除后,可能会有很多空闲空间可以回收,相关计算方法参考如下: 更新统计信息 Analyze table compute statistics ; 计算碎片空间 SELECT TABLE_N ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxPXqmM.html" rel="bookmark" class="title">python实现用于测试网站访问速率的方法</a>
					<div>
						  这是python编写的用于测试网站访问速率的代码片段,可以输出打开某url的时间,访问100次的平均时间,最大时间和最小时间等等 ? 1 2 3 4 5 6 7 8 9 10 11 12 13 1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pk2OP5M.html" rel="bookmark" class="title">PowerPoint 2013有什么新功能</a>
					<div>
						  PowerPoint 2013新功能. 一堆新模板 相对于Word 2013,PowerPoint的新功能不是那么显眼,除了新界面外,也有一堆新的模板,这是常用PowerPoint做演示文档的网友 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGJjQ6p.html" rel="bookmark" class="title">Lab模式下打造甜美的淡青色外景人物照片</a>
					<div>
						Lab模式下制作糖水图片是非常方便的,只需要找好合适的人物图片,简单的磨皮处理,然后在Lab模式下用通道替换或应用图像就可以快速增加糖水效果. 原图 &lt;点小图查看大图&gt; 最终效果 1.分析 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQNa0WM.html" rel="bookmark" class="title">Win8&period;1蓝牙怎么开？</a>
					<div>
						使用蓝牙的时候,就弹出这个窗口,但是蓝牙相关的服务已经开启. 以上是他的问题情况,小编初步分析是应该是蓝牙设备被禁用的关系,可以按下面的步骤尝试解决: 桌面上右键点击&quot;计算机&quot;,选 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJZR52z.html" rel="bookmark" class="title">新浪微博如何取消手机绑定&quest;</a>
					<div>
						  取消手机绑定有以下两种方法: 1.通过绑定的手机号发送短信jcbd(解除绑定的首字母)到1069009009进行解除. 2.登录微博首页在帐号-帐号设置-绑定手机-取消绑定,输入原有手机号,无需等 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pP84lrp.html" rel="bookmark" class="title">win7系统中开机提示找不到硬盘怎么办</a>
					<div>
						  1.硬盘数据线和电源线松动.氧化或断针 解决方法:尝试换电源接头.数据线或ide/sata接口. 2.可能是有些主板关闭了sata接口,找不到sata硬盘 解决方法:要在bios中把sata接口打 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pP8668p.html" rel="bookmark" class="title">怎样看出自己已经成功安装了百度工具栏</a>
					<div>
						  百度工具栏安装成功后,您可以在以下地方找到它: 控制面板--&gt;添加/删除程序--&gt;百度工具栏. 在IE浏览器的工具栏中增加了一个工具条,工具条最左侧有百度的的蓝红色图标,工具条上带有百 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBKJAkM.html" rel="bookmark" class="title">Insert Date and Time into Access&lowbar;应用技巧</a>
					<div>
						 &lt;% Function AccessDateTime (dateandtime) Dim myDay Dim myMonth Dim myYear myDay = Day(dateandtim ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boROdvz.html" rel="bookmark" class="title">浏览器内核转换-程序代码中完成浏览器内核切换成ie</a>
					<div>
						问题描述 程序代码中完成浏览器内核切换成ie 在使用java和jsp制作网站时,遇到了浏览器的问题 问题是需要解决 在代码中完成其他浏览器向ie浏览器内核的转换 不知道这个是不是可以实现 该如何实现					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6NEDWM.html" rel="bookmark" class="title">JAVA对XML文件的读写&lpar;有具体的代码和解析）</a>
					<div>
						XML 指可扩展标记语言(EXtensible Markup Language),是独立于软件和硬件的信息传输工具,应用于 web 开发的许多方面,常用于简化数据的存储和共享. xml指令 处理指令, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8A2oVz.html" rel="bookmark" class="title">ios客户端-https如何在移动端应用</a>
					<div>
						问题描述 https如何在移动端应用 我在nginx上配了ssl证书(startssl),主流浏览器访问没有问题,现在ios客户端需要跟服务器请求数据,但是把cer(pem--&gt;cer)文件导入 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGE8EkM.html" rel="bookmark" class="title">python进阶学习笔记（三）</a>
					<div>
						 本节通过SQLite了解数据库操作 -------------------------   数据库支持       使用简单的纯文本只能实现有退限的功能,所需要引入数据库,完成更强大的功能,本节使用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M94Ro3b.html" rel="bookmark" class="title">iTunes Connect&lpar;一&rpar; &mdash;&mdash; iOS应用上架到AppStore</a>
					<div>
						前言 基于本人对苹果的开发流程的渴望.所以很多东西一旦自己经历了,或者是别人经常会用到的时候,我就喜欢研究.并将自己以及别人的心得记录下来,方便自己及他人学习. 本篇,我将按照自己的思路对iOS应用上 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgRxn3b.html" rel="bookmark" class="title">广州患者发短信即可看病</a>
					<div>
						医疗信息化或搅热千亿市场 作为信息化应用在医疗服务领域的又一项尝新和突破,广州首推的短信随访医疗服务,不仅有助于开拓国内医疗服务改革新思路,而且能便利患者,刺激用户市场的潜在需求 ■本报记者 张小丹  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bE4o9Az.html" rel="bookmark" class="title">083&lowbar;《Delphi数据库开发经典实例精解》</a>
					<div>
						&lt;Delphi数据库开发经典实例精解&gt; Delphi 教程 系列书籍 (083) &lt;Delphi数据库开发经典实例精解&gt; 网友(邦)整理 EMail: shuaihj@163. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJqA6vp.html" rel="bookmark" class="title">详述从IaaS到PaaS的三种实现方法</a>
					<div>
						随着云计算平台的优势变得越来越清晰,从IaaS到PaaS似乎是一项比较轻松的工作了.但是,方法各有不同,而找到实施PaaS最好的方法就意味着在三个可能的选项中进行选择. 市场上有越来越多的声音在说,应 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M12LQ9p.html" rel="bookmark" class="title">百度史上最年轻的副总裁</a>
					<div>
						一年前,李彦宏曾写了一封内部邮件,其中有一句话是,&quot;移动互联网的趋势不可阻挡,我们要勇于革自己的命.&quot;一年后,一位30岁不到的年轻人李明远很好的完成了李彦宏对于百度移动互联网发展的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mx0kqBM.html" rel="bookmark" class="title">拉格朗日插值查找</a>
					<div>
						问题描述 拉格朗日插值查找 拉格朗日插值查找法:查找整型数据是非常快的 我有一个问题: 拉格朗日插值查找法:适合查找字符串吗? 求各位大神解释一下 解决方案 不适合.拉格朗日插值查找应用场景是有一组数 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWWnEeM.html" rel="bookmark" class="title">微软超过了谷歌，成为全球第二大市值科技公司</a>
					<div>
						微软首席执行官萨提亚·纳德拉(Satya Nadella)在上一财年获得了8430万美元的薪酬,几乎是上一年薪酬总额的11倍.微软的2014年财年于今年6月底结束,而纳德拉此时刚被任命为微软首席执行官 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boLYr3M.html" rel="bookmark" class="title">php更新mysql后获取改变行数的方法&lowbar;php技巧</a>
					<div>
						本文实例讲述了php更新mysql后获取改变行数的方法.分享给大家供大家参考.具体分析如下: 一个php更新mysql后获取改变的行数,在php中提供mysql函数来获取最后执行查询所影响的记录数:m ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.030 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
